File:  [ELWIX - Embedded LightWeight unIX -] / elwix / config / rc.subr
Revision 1.10.2.9: download - view: text, annotated - select for diffs - revision graph
Tue Oct 31 15:08:53 2017 UTC (6 years, 7 months ago) by misho
Branches: elwix2_6
Diff to: branchpoint 1.10: preferred, unified
adds new helper function Die()

    1: #
    2: # ELWIX project build helper subroutines
    3: #
    4: # (C) AITNET ltd - Sofia/Bulgaria <office@aitnet.org>
    5: #    by Michael Pounov <misho@elwix.org>
    6: #
    7: # $Id: rc.subr,v 1.10.2.9 2017/10/31 15:08:53 misho Exp $
    8: #
    9: 
   10: ### Dont edit this file !!!
   11: 
   12: Die() {
   13: 	echo -n "EXIT: " >&2; echo "$@" >&2
   14: 	exit 1
   15: }
   16: 
   17: CheckVer()
   18: {
   19: 	[ -z "$1" -o ! -r "$1" ] && return 1
   20: 
   21: 	cat $1 | awk '($1 == "ELWIX") { split($3, arr, ":"); printf("%s", arr[2]); }'
   22: 	return 0
   23: }
   24: 
   25: SnitVer()
   26: {
   27: 	install -d ${TOPDIR}
   28: 
   29: 	V=$(CheckVer $1)
   30: 
   31: 	if [ $? -ne 0 ]; then
   32: # file not found
   33: 		return 1
   34: 	elif [ X"$V" != X"${VERSION}" ]; then
   35: # different ELWIX version
   36: 		return 2
   37: 	fi
   38: 
   39: # already present file with same version
   40: 	return 0
   41: }
   42: 
   43: Create_etc_motd()
   44: {
   45: 	ELWIX_VER="ELWIX-${VERSION}_$2_${TARGET_ARCH}";
   46: 	ELWIX_HDR_MOTD="${ELWIX_VER} :: Build date ${BUILD_DATE}";
   47: 
   48: 	awk -v fo="${1:-motd}" 'BEGIN { print "'"${ELWIX_HDR_MOTD}"'" > fo; } { print $0 >> fo; }' \
   49: 		   ${CFGDIR}/elwix_signature.txt;
   50: }
   51: 
   52: # $1 = fs/elwix
   53: # $2 = config/etc/default
   54: MakeFS_var()
   55: {
   56: 	cd $1
   57: 
   58: 	install -d altroot;
   59: 
   60: 	install -d altroot/pkg;
   61: 	install -d altroot/pkg/db;
   62: 	install -d altroot/pkg/keys;
   63: 	install -d altroot/pkg/keys/revoked;
   64: 	install -d altroot/pkg/keys/trusted;
   65: 
   66: 	install -d altroot/var;
   67: 	install -d altroot/var/account;
   68: 	install -d altroot/var/at;
   69: 	install -d altroot/var/at/jobs;
   70: 	install -d altroot/var/at/spool;
   71: 	install -d -g 63 -m 0770 altroot/var/authpf;
   72: 	install -d altroot/var/backups;
   73: 	install -d -m 0750 altroot/var/cron;
   74: 	install -d -m 0700 altroot/var/cron/tabs;
   75: 	install -d altroot/var/db;
   76: 	install -d altroot/var/db/pkg;
   77: 	install -d -m 0555 altroot/var/empty;
   78: 	install -d altroot/var/log;
   79: 	install -d -o 80 -g 80 -m 0700 altroot/var/log/lighttpd;
   80: 	install -d -o 101 -g 101 altroot/var/log/quagga;
   81: 	install -d -o 883 -g 883 altroot/var/mqtt;
   82: 	install -d altroot/var/frm;
   83: 	install -d altroot/var/run;
   84: 	install -d -o 80 -g 80 altroot/var/run/lighttpd;
   85: 	install -d -o 101 -g 101 altroot/var/run/quagga;
   86: 	install -d altroot/var/spool;
   87: 	install -d -o 66 -g 68 -m 0775 altroot/var/spool/lock;
   88: 	install -d -o 80 -g 80 -m 0775 altroot/var/spool/lighttpd;
   89: 	install -d -o 80 -g 80 altroot/var/spool/lighttpd/sockets;
   90: 	install -d -g 1 altroot/var/spool/lpd;
   91: 	install -d -g 1 altroot/var/spool/output;
   92: 	install -d -g 1 altroot/var/spool/output/lpd;
   93: 	install -d -o 59 -g 59 altroot/var/unbound;
   94: 
   95: 	ln -fs /tmp altroot/var/tmp;
   96: 
   97: 	touch altroot/var/run/utmp
   98: 
   99: 	touch altroot/var/account/acct
  100: 
  101: 	touch altroot/var/log/elwix
  102: 	touch altroot/var/log/lastlog
  103: 	touch altroot/var/log/wifi.log
  104: 	touch altroot/var/log/utx.log
  105: 
  106: 	touch altroot/var/log/auth.log
  107: 	touch altroot/var/log/cron
  108: 	touch altroot/var/log/console.log
  109: 	touch altroot/var/log/debug.log
  110: 	touch altroot/var/log/init.log
  111: 	touch altroot/var/log/lpd-errs
  112: 	touch altroot/var/log/maillog
  113: 	touch altroot/var/log/messages
  114: 	touch altroot/var/log/security
  115: 	touch altroot/var/log/xferlog
  116: 	touch altroot/var/log/ppp.log
  117: 	chgrp 69 altroot/var/log/ppp.log
  118: 
  119: #	install -v $2/resolv.safe altroot/var/run/resolv.conf
  120: 	install -v ${WORLD}/usr/share/keys/pkg/trusted/* altroot/pkg/keys/trusted
  121: 
  122: 	cd -
  123: }
  124: 
  125: # $1 = fs/elwix
  126: # $2 = config/etc/default
  127: # $3 = name
  128: MakeFS_etc()
  129: {
  130: 	InstallDir $2 $1/etc
  131: 
  132: 	chown -R root:wheel $1/etc;
  133: 
  134: 	case "$3" in
  135: 		uboot)
  136: 			;;
  137: 		*)
  138: #			chmod 0600 $1/etc/opieaccess;
  139: #			chmod 0600 $1/etc/opiekeys;
  140: 			;;
  141: 	esac
  142: 
  143: 	chmod 0600 $1/etc/master.passwd;
  144: 	chmod 0600 $1/etc/spwd.db;
  145: 	chmod 0600 $1/etc/ssh/ssh_host_dsa_key;
  146: 	chmod 0600 $1/etc/ssh/ssh_host_key;
  147: 	chmod 0600 $1/etc/ssh/ssh_host_rsa_key;
  148: 	chmod 0600 $1/etc/ssh/ssh_host_ecdsa_key;
  149: 	chmod 0600 $1/etc/ssh/ssh_host_ed25519_key;
  150: 
  151: 	chmod 0440 $1/etc/sudoers;
  152: 
  153: 	mkdir -p $1/etc/mqtt;
  154: 	chgrp -R 883 $1/etc/mqtt;
  155: 	chown -R 883 $1/etc/mqtt;
  156: 
  157: 	ln -sf /etc/rc.s $1/etc/rc.S
  158: 
  159: 	ln -sf /usr/share/zoneinfo/${TIMEZONE} $1/etc/localtime;
  160: 	ln -sf /usr/share/misc/termcap $1/etc/termcap;
  161: 
  162: #	ln -sf /var/run/resolv.conf $1/etc/resolv.conf;
  163: 
  164: #	ln -sf /elwix/pkg/etc/mk.conf $1/etc/mk.conf;
  165: 
  166: 	echo ${TARGET_ARCH} >$1/etc/platform;
  167: 
  168: 	Create_etc_motd $1/etc/motd $3;
  169: 
  170: 	CleanCVS $1
  171: 	CleanCVS $1/etc
  172: }
  173: 
  174: # $1 = fs/elwix
  175: MakeFS_home()
  176: {
  177: 	install -d $1/root/.ssh
  178: 	[ -r ${CFGDIR}/root.skel/ssh/authorized_keys2 ] && \
  179: 		install -v ${CFGDIR}/root.skel/ssh/authorized_keys2 $1/root/.ssh;
  180: 
  181: 	install -v ${CFGDIR}/root.skel/cshrc $1/root/.cshrc;
  182: 	install -v ${CFGDIR}/root.skel/login $1/root/.login;
  183: 	install -v ${CFGDIR}/root.skel/logout $1/root/.logout;
  184: 	install -v ${CFGDIR}/root.skel/profile $1/root/.profile;
  185: 	install -v ${CFGDIR}/root.skel/vimrc $1/root/.vimrc;
  186: }
  187: 
  188: # $1 = fs
  189: MakeFS_boot()
  190: {
  191: 	InstallDir ${WORLD}/boot $1/boot
  192: 
  193: 	install -m 644 ${CFGDIR}/boot/boot.config $1;
  194: 
  195: 	case ${TARGET} in
  196: 		i386|amd64)
  197: 			install -m 444 ${CFGDIR}/boot/logo-elwix.4th $1/boot;
  198: 			install -m 444 ${CFGDIR}/boot/brand-elwix.4th $1/boot;
  199: 			install -m 444 ${CFGDIR}/boot/menu.4th $1/boot;
  200: 			;;
  201: 		*)
  202: 			;;
  203: 	esac
  204: 
  205: 	install -m 444 ${KERNDEVHINTS} $1/boot/device.hints;
  206: 
  207: 	if [ -r ${CFGDIR}/boot/loader_${TARGET_ARCH}.conf ]; then
  208: 		install -m 644 ${CFGDIR}/boot/loader_${TARGET_ARCH}.conf $1/boot/loader.conf;
  209: 		install -m 644 ${CFGDIR}/boot/loader.conf.local $1/boot/loader.conf.local;
  210: 	fi;
  211: }
  212: 
  213: # $1 = ELWIX install list config
  214: # $2 = From World dir
  215: # $3 = To Dest dir
  216: InstallList()
  217: {
  218: 	local TMPFILE=$(mktemp -q /tmp/instlist.XXXXXX)
  219: 	if [ $? -ne 0 ]; then
  220: 		echo "Error:: Can't create temp file, exiting..."
  221: 		exit 1
  222: 	fi
  223: 
  224: 	sed -nE -e 's/^ *([^ #]+) */\1/p' < $1 | tr ':' '\n' >$TMPFILE
  225: 	cd $2
  226: 	for i in $(cat $TMPFILE); do
  227: 		if [ -x $i ]; then
  228: 			echo "Strip '$i'"
  229: 			${CEXEC} chflags -f noschg $i
  230: 			${CEXEC} strip -s $i
  231: 		fi
  232: 	done
  233: 	cd -
  234: 	tar -C $2 -cvf - -T $TMPFILE | tar -C $3 -x -f -
  235: 	rm -f $TMPFILE
  236: }
  237: 
  238: # $1 = From dir
  239: # $2 = To dir
  240: InstallDir()
  241: {
  242: 	cd $1
  243: 	pax -rw -pe -X . $2
  244: 	cd -
  245: }
  246: 
  247: # $* = Program arguments for install tool
  248: InstallProg()
  249: {
  250: 	install -c $*
  251: }
  252: 
  253: # $1 = file_pattern
  254: # $2 = From dir
  255: # $3 = To dir
  256: InstallFiles()
  257: {
  258: 	if [ -d "$2" ]; then
  259: 		cd $2
  260: 		find . -type f -name "$1" | 
  261: 			tar -cvf - -T - | tar -C $3 -xf -
  262: 		cd -
  263: 	fi
  264: }
  265: 
  266: # $1 = From dir
  267: # $2 = To dir
  268: InstallLibs()
  269: {
  270: 	${CEXEC} find -X $2 ! -name "*.ko" -and -type f | \
  271: 		xargs readelf -d 2>&- | grep "NEEDED" | sort | uniq | \
  272: 		awk '($2 == "(NEEDED)") { print substr($5, 2, length($5) - 2); }' \
  273: 		2>/dev/null >${DEST}/elwix_mklibs.tmp
  274: 	for i in $(cat ${DEST}/elwix_mklibs.tmp); do
  275: 		echo $i
  276: 		${CEXEC} find $1 -type f -name $i -exec install -v {} $LIBS \\\;
  277: 		${CEXEC} chflags -f noschg $LIBS/$i
  278: 		${CEXEC} strip -s $LIBS/$i
  279: 	done
  280: #	${CEXEC} find -X $2 ! -name "*.ko" -and -type f -and -perm +111 | \
  281: #		xargs ldd -f "%p\n" 2> /dev/null | sort | uniq | \
  282: #		sed 's|^/||' >${DEST}/elwix_mklibs.conf
  283: #	InstallList ${DEST}/elwix_mklibs.conf $1 $2
  284: }
  285: 
  286: # $1 = Directory for clean
  287: CleanCVS()
  288: {
  289: 	find $1 -type d -name CVS -exec rm -rf {} \; >/dev/null 2>&1
  290: 	find $1 -type f -name .#\* -exec rm -f {} \; >/dev/null 2>&1
  291: }
  292: 
  293: # $1 = file_pattern
  294: # $2 = From dir
  295: StripFiles()
  296: {
  297: 	if [ -d "$2" ]; then
  298: 		local TMPFILE=$(mktemp -q /tmp/instlist.XXXXXX)
  299: 		if [ $? -ne 0 ]; then
  300: 			echo "Error:: Can't create temp file, exiting..."
  301: 			exit 1
  302: 		fi
  303: 
  304: 		cd $2
  305: 		find . -type f -name "$1" >$TMPFILE
  306: 		for i in $(cat $TMPFILE); do
  307: 			if [ -x $i ]; then
  308: 				echo "Strip '$i'"
  309: 				${CEXEC} chflags -f noschg $i
  310: 				${CEXEC} strip -s $i
  311: 			fi
  312: 		done
  313: 		cd -
  314: 		rm -f $TMPFILE
  315: 	fi
  316: }

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>